Loading...
Searching...
No Matches
juce::TracktionMarketplaceStatus Class Reference

## Detailed Description

An implementation of the OnlineUnlockStatus class which talks to the Tracktion Marketplace server.

For details about how to use this class, see the docs for the base class: OnlineUnlockStatus. Basically, you need to inherit from it, and implement all the pure virtual methods to tell it about your product.

See also
  OnlineUnlockStatus, OnlineUnlockForm, KeyGeneration

The documentation for this class was generated from the following file:

- juce_product_unlocking/marketplace/juce_TracktionMarketplaceStatus.h

Inheritance diagram for juce::TracktionMarketplaceStatus:

## Public Member Functions

| TracktionMarketplaceStatus ()
bool | doesProductIDMatch (const String &returnedIDFromServer) override
| This must check whether a product ID string that the server returned is OK for unlocking the current app.
URL | getServerAuthenticationURL () override
| Returns the URL of the authentication API.
String | getWebsiteName () override
| Returns the name of the web-store website, not for communication, but for presenting to the user.
String | readReplyFromWebserver (const String &email, const String &password) override
| Subclasses that talk to a particular web-store will implement this method to contact their webserver and attempt to unlock the current machine for the given username and password.
void | userCancelled () override
| This method will be called if the user cancels the connection to the webserver by clicking the cancel button in OnlineUnlockForm::OverlayComp.
Public Member Functions inherited from juce::OnlineUnlockStatus
| OnlineUnlockStatus ()
virtual | ~OnlineUnlockStatus ()
| Destructor.
virtual String | getProductID ()=0
| This must return your product's ID, as allocated by the store.
virtual RSAKey | getPublicKey ()=0
| This must return the RSA public key for authenticating responses from the server for this app.
virtual void | saveState (const String &)=0
| This method must store the given string somewhere in your app's persistent properties, so it can be retrieved later by getState().
virtual String | getState ()=0
| This method must retrieve the last state that was provided by the saveState method.
virtual StringArray | getLocalMachineIDs ()
| Returns a list of strings, any of which should be unique to this physical computer.
virtual String | getMessageForConnectionFailure (bool isInternetConnectionWorking)
virtual String | getMessageForUnexpectedReply ()
var | isUnlocked () const
| Returns true if the product has been successfully authorised for this machine.
Time | getExpiryTime () const
| Returns the Time when the keyfile expires.
void | setUserEmail (const String &usernameOrEmail)
| Optionally allows the app to provide the user's email address if it is known.
String | getUserEmail () const
| Returns the user's email address if known.
Result | applyKeyFile (const String &keyFileContent)
| Attempts to perform an unlock using a block of key-file data provided.
UnlockResult | attemptWebserverUnlock (const String &email, const String &password)
| Contacts the webserver and attempts to perform a registration with the given user details.
void | load ()
| Attempts to load the status from the state retrieved by getState().
void | save ()
| Triggers a call to saveState which you can use to store the current unlock status in your app's settings.

## Constructors and Destructors

## TracktionMarketplaceStatus()

juce::TracktionMarketplaceStatus::TracktionMarketplaceStatus | ( |  | ) |

Referenced by userCancelled().

## Member Functions

## doesProductIDMatch()

bool juce::TracktionMarketplaceStatus::doesProductIDMatch | ( | const String & | returnedIDFromServer | ) |

override virtual

This must check whether a product ID string that the server returned is OK for unlocking the current app.

Implements juce::OnlineUnlockStatus.

## getServerAuthenticationURL()

URL juce::TracktionMarketplaceStatus::getServerAuthenticationURL | ( |  | ) |

override virtual

Returns the URL of the authentication API.

Implements juce::OnlineUnlockStatus.

## getWebsiteName()

String juce::TracktionMarketplaceStatus::getWebsiteName | ( |  | ) |

override virtual

Returns the name of the web-store website, not for communication, but for presenting to the user.

Implements juce::OnlineUnlockStatus.

## readReplyFromWebserver()

String juce::TracktionMarketplaceStatus::readReplyFromWebserver | ( | const String & | email,
|  | const String & | password )

override virtual

Subclasses that talk to a particular web-store will implement this method to contact their webserver and attempt to unlock the current machine for the given username and password.

The return value is the XML text from the server which contains error information and/or the encrypted keyfile.

Implements juce::OnlineUnlockStatus.

## userCancelled()

void juce::TracktionMarketplaceStatus::userCancelled | ( |  | ) |

override virtual

This method will be called if the user cancels the connection to the webserver by clicking the cancel button in OnlineUnlockForm::OverlayComp.

The default implementation of this method does nothing but you should use it to cancel any WebInputStreams that may be connecting.

Reimplemented from juce::OnlineUnlockStatus.

References TracktionMarketplaceStatus().

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited